var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React, { PropTypes as PT } from 'react';

import css from '../../styles/alert.css';

/**
 * Alert messages
 */
export default function Alert(_ref) {
	var children = _ref.children,
	    className = _ref.className,
	    type = _ref.type,
	    props = _objectWithoutProperties(_ref, ['children', 'className', 'type']);

	var classes = [css.alert, css[type]];

	if (className) {
		classes.push(className);
	}

	return React.createElement(
		'div',
		_extends({}, props, {
			className: classes.join(' ')
		}),
		children
	);
}

Alert.propTypes = {
	/**
  * Contents of the Alert
  */
	children: PT.node.isRequired,

	/**
  * Additional className
  */
	className: PT.string,

	/**
  * Type of the Alert
  */
	type: PT.oneOf(['info', 'success', 'warning', 'error'])
};

Alert.defaultProps = {
	type: 'info'
};