var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React, { PropTypes as PT } from 'react';

import css from '../../styles/card.css';

/**
 * A card to be used for displaying things
 */
export default function Card(_ref) {
	var children = _ref.children,
	    className = _ref.className,
	    image = _ref.image,
	    props = _objectWithoutProperties(_ref, ['children', 'className', 'image']);

	var classes = [css.card];

	if (className) {
		classes.push(className);
	}

	if (image) {
		classes.push(css.imageCard);
	}

	return React.createElement(
		'div',
		_extends({}, props, { className: classes.join(' ') }),
		image && React.createElement(
			'div',
			{ className: css.imageContainer },
			React.createElement('img', { src: image, alt: '' })
		),
		React.createElement(
			'div',
			{ className: css.content },
			children
		)
	);
}

Card.propTypes = {
	/**
  * Children for this component
  */
	children: PT.node,

	/**
  * Additional className
  */
	className: PT.string,

	/**
  * Image to be displayed in the card
  */
	image: PT.string
};