var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { PropTypes as PT } from 'react';

import css from '../../styles/menu.css';

var Menu = function (_React$Component) {
	_inherits(Menu, _React$Component);

	function Menu() {
		_classCallCheck(this, Menu);

		return _possibleConstructorReturn(this, (Menu.__proto__ || Object.getPrototypeOf(Menu)).apply(this, arguments));
	}

	_createClass(Menu, [{
		key: 'getChildContext',
		value: function getChildContext() {
			return {
				isSubMenu: true
			};
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    inverted = _props.inverted,
			    className = _props.className,
			    children = _props.children;
			var isSubMenu = this.context.isSubMenu;

			var classes = [css.menu];

			if (inverted) {
				classes.push(css.inverted);
			}

			if (isSubMenu) {
				classes.push(css.subMenu);
			}

			if (className) {
				classes.push(className);
			}

			return React.createElement(
				'div',
				{ className: classes.join(' ') },
				children
			);
		}
	}]);

	return Menu;
}(React.Component);

Menu.propTypes = {
	/**
  * Contents of the Menu
  */
	children: PT.node.isRequired,

	/**
  * Additional className
  */
	className: PT.string,

	/**
  * Inverted menu?
  */
	inverted: PT.bool
};
Menu.childContextTypes = {
	isSubMenu: PT.bool
};
Menu.contextTypes = {
	isSubMenu: PT.bool
};
export default Menu;