import React, { PropTypes as PT } from 'react';
import { Provider, Header, Body } from 'reactabular-table';

import css from '../../styles/table.css';

export default function Table(_ref) {
	var columns = _ref.columns,
	    rows = _ref.rows,
	    rowKey = _ref.rowKey,
	    className = _ref.className;

	var classes = [css.table];

	if (className) {
		classes.push(className);
	}

	return React.createElement(
		Provider,
		{ columns: columns, className: classes.join(' ') },
		React.createElement(Header, null),
		React.createElement(Body, { rows: rows, rowKey: rowKey })
	);
}

Table.propTypes = {
	rowKey: PT.string.isRequired,
	rows: PT.arrayOf(PT.object).isRequired,
	columns: PT.arrayOf(PT.object).isRequired,
	className: PT.string
};