var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { PropTypes as PT } from 'react';

import css from '../../../styles/input.css';
import wrapWithField from '../../utils/wrapWithField';

var inputPropTypes = {
	/**
  * Function to call with the updated value
  */
	change: PT.func.isRequired,

	/**
  * Name of the input
  */
	name: PT.string,

	/**
  * Function to call with input's change event
  */
	onChange: PT.func,

	/**
  * Options for the input
  */
	options: PT.arrayOf(PT.shape({
		value: PT.string.isRequired
	})).isRequired,

	/**
  * The value of the input
  */
	value: PT.arrayOf(PT.string)
};

export var InputMultiOptionCheckboxes = function (_React$Component) {
	_inherits(InputMultiOptionCheckboxes, _React$Component);

	function InputMultiOptionCheckboxes() {
		_classCallCheck(this, InputMultiOptionCheckboxes);

		var _this = _possibleConstructorReturn(this, (InputMultiOptionCheckboxes.__proto__ || Object.getPrototypeOf(InputMultiOptionCheckboxes)).call(this));

		_this.handleChange = _this.handleChange.bind(_this);
		return _this;
	}

	_createClass(InputMultiOptionCheckboxes, [{
		key: 'handleChange',
		value: function handleChange(ev) {
			var value = [].concat(_toConsumableArray(this.props.value || []));
			var i = parseInt(ev.target.dataset.index, 10);
			var v = this.props.options[i].value;

			if (ev.target.checked) {
				value.push(v);
			} else {
				var idx = value.indexOf(v);

				if (idx > -1) {
					value.splice(idx, 1);
				}
			}

			this.props.change(value);

			if (this.props.onChange) {
				this.props.onChange(ev);
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    name = _props.name,
			    options = _props.options,
			    value = _props.value;


			return React.createElement(
				'div',
				{ className: css.fieldset },
				options.map(function (option, idx) {
					return React.createElement(
						'label',
						{ key: idx, className: css.option },
						React.createElement('input', {
							type: 'checkbox',
							'data-index': idx,
							name: name,
							checked: value.indexOf(option.value) > -1,
							onChange: _this2.handleChange,
							value: option.value
						}),
						React.createElement(
							'span',
							null,
							option.label
						)
					);
				})
			);
		}
	}]);

	return InputMultiOptionCheckboxes;
}(React.Component);

InputMultiOptionCheckboxes.propTypes = inputPropTypes;
export var InputMultiOptionSelect = function (_React$Component2) {
	_inherits(InputMultiOptionSelect, _React$Component2);

	function InputMultiOptionSelect() {
		_classCallCheck(this, InputMultiOptionSelect);

		var _this3 = _possibleConstructorReturn(this, (InputMultiOptionSelect.__proto__ || Object.getPrototypeOf(InputMultiOptionSelect)).call(this));

		_this3.handleChange = _this3.handleChange.bind(_this3);
		return _this3;
	}

	_createClass(InputMultiOptionSelect, [{
		key: 'handleChange',
		value: function handleChange(ev) {
			var _this4 = this;

			var value = [].slice.call(ev.target.options).filter(function (option) {
				return option.selected;
			}).map(function (option) {
				return option.dataset.index;
			}).map(function (idx) {
				return _this4.props.options[idx].value;
			});

			this.props.change(value);

			if (this.props.onChange) {
				this.props.onChange(ev);
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _props2 = this.props,
			    name = _props2.name,
			    options = _props2.options,
			    value = _props2.value;


			return React.createElement(
				'select',
				{
					className: css.input,
					multiple: true,
					name: name,
					onChange: this.handleChange,
					value: value
				},
				options.map(function (option, idx) {
					return React.createElement(
						'option',
						{
							key: idx,
							'data-index': idx,
							value: option.value
						},
						option.label
					);
				})
			);
		}
	}]);

	return InputMultiOptionSelect;
}(React.Component);

/**
 * Input type which allows the user to select multiple options
 * from multiple choices. It can be rendered either as a "multiple
 * select" box or as a set of checkboxes.
 */
InputMultiOptionSelect.propTypes = inputPropTypes;
export function InputMultiOption(_ref) {
	var style = _ref.style,
	    props = _objectWithoutProperties(_ref, ['style']);

	return React.createElement(
		'div',
		{ className: css.container },
		style === 'checkbox' ? React.createElement(InputMultiOptionCheckboxes, props) : React.createElement(InputMultiOptionSelect, props)
	);
}

InputMultiOption.propTypes = _extends({}, inputPropTypes, {

	/**
  * Style to render the input in
  */
	style: PT.oneOf(['checkbox', 'select'])
});

InputMultiOption.defaultProps = {
	style: 'checkbox'
};

export default wrapWithField(InputMultiOption);