var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { PropTypes as PT } from 'react';

import css from '../../../styles/input.css';
import wrapWithField from '../../utils/wrapWithField';

var inputPropTypes = {
	/**
  * Function to call with the updated value
  */
	change: PT.func.isRequired,

	/**
  * Name of the input
  */
	name: PT.string,

	/**
  * Function to call with input's change event
  */
	onChange: PT.func,

	/**
  * Options for the input
  */
	options: PT.arrayOf(PT.shape({
		value: PT.string.isRequired
	})).isRequired,

	/**
  * The value of the input
  */
	value: PT.string
};

export var InputSingleOptionRadios = function (_React$Component) {
	_inherits(InputSingleOptionRadios, _React$Component);

	function InputSingleOptionRadios() {
		_classCallCheck(this, InputSingleOptionRadios);

		var _this = _possibleConstructorReturn(this, (InputSingleOptionRadios.__proto__ || Object.getPrototypeOf(InputSingleOptionRadios)).call(this));

		_this.handleChange = _this.handleChange.bind(_this);
		return _this;
	}

	_createClass(InputSingleOptionRadios, [{
		key: 'handleChange',
		value: function handleChange(ev) {
			var idx = parseInt(ev.target.dataset.index, 10);
			this.props.change(this.props.options[idx].value);

			if (this.props.onChange) {
				this.props.onChange(ev);
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    name = _props.name,
			    options = _props.options,
			    value = _props.value;


			return React.createElement(
				'div',
				{ className: css.fieldset },
				options.map(function (option, idx) {
					return React.createElement(
						'label',
						{ key: idx, className: css.option },
						React.createElement('input', {
							type: 'radio',
							'data-index': idx,
							name: name,
							checked: option.value === value,
							onChange: _this2.handleChange,
							value: option.value
						}),
						React.createElement(
							'span',
							null,
							option.label
						)
					);
				})
			);
		}
	}]);

	return InputSingleOptionRadios;
}(React.Component);

InputSingleOptionRadios.propTypes = inputPropTypes;
export var InputSingleOptionSelect = function (_React$Component2) {
	_inherits(InputSingleOptionSelect, _React$Component2);

	function InputSingleOptionSelect() {
		_classCallCheck(this, InputSingleOptionSelect);

		var _this3 = _possibleConstructorReturn(this, (InputSingleOptionSelect.__proto__ || Object.getPrototypeOf(InputSingleOptionSelect)).call(this));

		_this3.handleChange = _this3.handleChange.bind(_this3);
		return _this3;
	}

	_createClass(InputSingleOptionSelect, [{
		key: 'handleChange',
		value: function handleChange(ev) {
			var options = ev.target.options;
			var idx = parseInt(options[options.selectedIndex].dataset.index, 10);
			this.props.change(this.props.options[idx].value);

			if (this.props.onChange) {
				this.props.onChange(ev);
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _props2 = this.props,
			    name = _props2.name,
			    options = _props2.options,
			    value = _props2.value;


			return React.createElement(
				'select',
				{
					className: css.input,
					name: name,
					onChange: this.handleChange,
					value: value
				},
				options.map(function (option, idx) {
					return React.createElement(
						'option',
						{
							key: idx,
							'data-index': idx,
							value: option.value
						},
						option.label
					);
				})
			);
		}
	}]);

	return InputSingleOptionSelect;
}(React.Component);

/**
 * Input type which allows the user to select a single option
 * from multiple choices. It can be rendered either as a dropdown
 * box or as a set of radio buttons.
 */
InputSingleOptionSelect.propTypes = inputPropTypes;
export function InputSingleOption(_ref) {
	var style = _ref.style,
	    props = _objectWithoutProperties(_ref, ['style']);

	var classes = [css.container];

	if (style === 'select') {
		classes.push(css.arrow);
	}

	return React.createElement(
		'div',
		{ className: classes.join(' ') },
		style === 'radio' ? React.createElement(InputSingleOptionRadios, props) : React.createElement(InputSingleOptionSelect, props)
	);
}

InputSingleOption.propTypes = _extends({}, inputPropTypes, {

	/**
  * Style to render the input in
  */
	style: PT.oneOf(['radio', 'select'])
});

InputSingleOption.defaultProps = {
	style: 'radio'
};

export default wrapWithField(InputSingleOption);