function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';

import Field from '../components/Field';

export default function wrapWithField(Input) {
	function WrappedInput(_ref) {
		var className = _ref.className,
		    error = _ref.error,
		    label = _ref.label,
		    orientation = _ref.orientation,
		    props = _objectWithoutProperties(_ref, ['className', 'error', 'label', 'orientation']);

		return React.createElement(
			Field,
			{ className: className, error: error, label: label, orientation: orientation },
			React.createElement(Input, props)
		);
	}

	WrappedInput.propTypes = Field.PropTypes;

	return WrappedInput;
}