'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = Button;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _button = require('../../styles/button.css');

var _button2 = _interopRequireDefault(_button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
 * General purpose button.
 */
function Button(_ref) {
	var children = _ref.children,
	    primary = _ref.primary,
	    submit = _ref.submit,
	    props = _objectWithoutProperties(_ref, ['children', 'primary', 'submit']);

	var classes = [_button2.default.button];

	if (primary) {
		classes.push(_button2.default.primary);
	}

	if (props.className) {
		classes.push(props.className);
	}

	return _react2.default.createElement(
		'button',
		_extends({}, props, {
			type: submit ? 'submit' : 'button',
			className: classes.join(' ')
		}),
		children
	);
}

Button.propTypes = {
	/**
  * Contents of the button
  */
	children: _react.PropTypes.node,

	/**
  * Additional classes for the button
  */
	className: _react.PropTypes.string,

	/**
  * True if button is a primary button
  */
	primary: _react.PropTypes.bool,

	/**
  * True if button is a submit button
  */
	submit: _react.PropTypes.bool
};

Button.defaultProps = {
	primary: false,
	submit: false
};