'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = Field;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _field = require('../../styles/field.css');

var _field2 = _interopRequireDefault(_field);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
 * Generic input wrapper.
 */
function Field(_ref) {
	var children = _ref.children,
	    error = _ref.error,
	    label = _ref.label,
	    orientation = _ref.orientation,
	    props = _objectWithoutProperties(_ref, ['children', 'error', 'label', 'orientation']);

	var classes = [_field2.default.container];

	if (orientation === 'horizontal') {
		classes.push(_field2.default.isHorizontal);
	}

	if (props.className) {
		classes.push(props.className);
	}

	return _react2.default.createElement(
		'div',
		_extends({}, props, { className: classes.join(' ') }),
		!!label && _react2.default.createElement(
			'label',
			{ className: _field2.default.label },
			label
		),
		_react2.default.createElement(
			'div',
			{ className: _field2.default.inputWrap },
			children,
			!!error && _react2.default.createElement(
				'em',
				{ className: _field2.default.error },
				error
			)
		)
	);
}

Field.propTypes = {
	/**
  * Contents of the field
  */
	children: _react.PropTypes.node,

	/**
  * Error to display
  */
	error: _react.PropTypes.string,

	/**
  * Label for the field
  */
	label: _react.PropTypes.string,

	/**
  * Additional classnames
  */
	className: _react.PropTypes.string,

	/**
  * Orientation of the field
  */
	orientation: _react.PropTypes.oneOf(['horizontal', 'vertical'])
};