'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.UnityEmbed = UnityEmbed;
exports.default = Game;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _game = require('../../styles/game.css');

var _game2 = _interopRequireDefault(_game);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function UnityEmbed(_ref) {
	var content = _ref.content;

	var unityInstalled = typeof navigator !== 'undefined' && navigator.mimeTypes && navigator.mimeTypes['application/vnd.unity'] && navigator.mimeTypes['application/vnd.unity'].enabledPlugin && navigator.plugins && navigator.plugins['Unity Player'];

	if (!unityInstalled) {
		return _react2.default.createElement(
			'div',
			{ className: _game2.default.notInstalled },
			_react2.default.createElement(
				'p',
				null,
				'Unity Web Player not installed.'
			)
		);
	}

	return _react2.default.createElement('embed', {
		type: 'application/vnd.unity',
		className: _game2.default.game,
		src: content
	});
}

UnityEmbed.propTypes = {
	content: _react.PropTypes.string
};

function Game(_ref2) {
	var className = _ref2.className,
	    content = _ref2.content,
	    height = _ref2.height,
	    type = _ref2.type,
	    width = _ref2.width;

	var classes = [_game2.default.container];
	if (className) {
		classes.push(className);
	}

	var padding = height / width * 100;

	return _react2.default.createElement(
		'div',
		{ className: classes.join(' '), style: { maxWidth: width } },
		_react2.default.createElement('div', { style: { paddingBottom: padding + '%' } }),
		type === 'flash' ? _react2.default.createElement(
			'object',
			{ data: content, className: _game2.default.game },
			_react2.default.createElement('param', { name: 'movie', value: content }),
			_react2.default.createElement('param', { name: 'allowScriptAccess', value: 'always' }),
			_react2.default.createElement('param', { name: 'allowNetworking', value: 'internal' })
		) : type === 'unity' ? _react2.default.createElement(UnityEmbed, { content: content }) : type === 'iframe' ? _react2.default.createElement('iframe', { src: content, width: width, height: height, className: _game2.default.game }) : type === 'custom' ? _react2.default.createElement('div', { dangerouslySetInnerHTML: { __html: content } }) : 'unsupported game type'
	);
}

Game.propTypes = {
	/**
  * Additional class names
  */
	className: _react.PropTypes.string,

	/**
  * URL to the content
  */
	content: _react.PropTypes.string.isRequired,

	/**
  * Height of the game
  */
	height: _react.PropTypes.number.isRequired,

	/**
  * Type of the game
  */
	type: _react.PropTypes.oneOf(['flash', 'unity', 'iframe']).isRequired,

	/**
  * Width of the game
  */
	width: _react.PropTypes.number.isRequired
};