'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactGateway = require('react-gateway');

var _reactModal = require('react-modal2');

var _reactModal2 = _interopRequireDefault(_reactModal);

var _modal = require('../../styles/modal.css');

var _modal2 = _interopRequireDefault(_modal);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable import/extensions, import/no-unresolved */


_reactModal2.default.getApplicationElement = function () {
	return document.getElementById('app');
};

/**
 * The modal component takes a bit more effort to use, since you
 * will have to implement the [react-gateway](https://github.com/cloudflare/react-gateway)
 * library in your application. `react-gateway` allows react to
 * render part of its tree in another part of the dom. This is
 * exceptionally handy for things like modals since they're layered
 * above your application.
 *
 * This modal uses `<Gateway into="modal">`,
 * so you'll have to create a `<GatewayDest name="modal" />` for it
 * to render into.
 *
 * This modal also uses the `react-modal2` library, this helps with a
 * bunch of accessability issues. One of the things it does is to "hide"
 * the rest of you app from screen readers whenever the modal opens. It
 * also ensures that tabbing through inputs and such you won't accidentally
 * tab onto things which are behind the modal.
 *
 * In order to hide your application, there needs to be an element with
 * the id `app` - this should be the root element which holds the rest of
 * your application. Be mindful that the `<GatewayDest />` should be outside
 * of this element.
 *
 * Keeping the above in mind, below is an extremely trivial example of how you
 * would prepare your app to use the modal.
 *
 * ```
 * import React from 'react';
 * import ReactDOM from 'react-dom';
 * import { GatewayDest, GatewayProvider } from 'react-gateway';
 *
 * ReactDOM.render((
 *   <GatewayProvider>
 *     <div id="app">
 *       Your application goes here
 *     </div>
 *     <GatewayDest name="modal" />
 *   </GatewayProvider>
 * ));
 * ```
 *
 * Once your application is set up, you can simply render the modal. This will
 * also work server-side. An ideal way to use this, is to render the modal when
 * visiting a certain route, ensuring that the modal even works when the user has
 * javascript disabled (and also for SEO purposes).
 */

var Modal = function (_React$Component) {
	_inherits(Modal, _React$Component);

	function Modal() {
		_classCallCheck(this, Modal);

		return _possibleConstructorReturn(this, (Modal.__proto__ || Object.getPrototypeOf(Modal)).apply(this, arguments));
	}

	_createClass(Modal, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			document.body.style.overflow = 'hidden';
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			document.body.style.overflow = '';
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    actions = _props.actions,
			    children = _props.children,
			    className = _props.className,
			    onClose = _props.onClose,
			    style = _props.style,
			    title = _props.title;


			var modalClasses = [_modal2.default.container];
			if (className) modalClasses.push(className);

			return _react2.default.createElement(
				_reactGateway.Gateway,
				{ into: 'modal' },
				_react2.default.createElement(
					_reactModal2.default,
					{
						onClose: onClose,
						backdropClassName: _modal2.default.backdrop,
						modalClassName: modalClasses.join(' '),
						modalStyles: style
					},
					_react2.default.createElement(
						'header',
						{ className: _modal2.default.header },
						_react2.default.createElement(
							'h1',
							{ className: _modal2.default.title },
							title
						),
						_react2.default.createElement(
							'button',
							{
								type: 'button',
								className: _modal2.default.close,
								onClick: onClose
							},
							'Close'
						)
					),
					_react2.default.createElement(
						'div',
						{ className: _modal2.default.body },
						children
					),
					!!actions && !!actions.length && _react2.default.createElement(
						'footer',
						{ className: _modal2.default.footer },
						actions.map(function (action, idx) {
							return _react2.default.cloneElement(action, { key: idx });
						})
					)
				)
			);
		}
	}]);

	return Modal;
}(_react2.default.Component);

Modal.propTypes = {
	/**
  * Action buttons to place in the footer
  */
	actions: _react.PropTypes.arrayOf(_react.PropTypes.node),

	/**
  * Contents of the modal
  */
	children: _react.PropTypes.node,

	/**
  * Additional class(es) to assign to the modal
  */
	className: _react.PropTypes.string,

	/**
  * Function to execute when the user requests the modal to close
  */
	onClose: _react.PropTypes.func.isRequired,

	/**
  * Inline styles to set on the modal
  */
	style: _react.PropTypes.objectOf(_react.PropTypes.string),

	/**
  * Title of the modal
  */
	title: _react.PropTypes.string
};
exports.default = Modal;